security:
    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        fetcher:
            id: App\Security\UserProvider
    encoders:
        App\Security\UserIdentity: native
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            anonymous: true
            user_checker: App\Security\UserChecker
            guard:
                authenticators:
                    - App\Security\LoginFormAuthenticator
                    - App\Security\OAuth\FacebookAuthenticator
                    - App\Security\OAuth\GoogleAuthenticator
                entry_point: App\Security\LoginFormAuthenticator
            remember_me:
                secret: '%kernel.secret%'
                lifetime: 604800
                path: /

                # activate different ways to authenticate
                # https://symfony.com/doc/current/security.html#firewalls-authentication
            form_login: true
            logout:
                path: app_logout

            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#firewalls-authentication

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true


    role_hierarchy:
        ROLE_ADMIN:
            - ROLE_USER
    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/signup, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/oauth, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/profile, roles: ROLE_USER }
        - { path: ^/admin, roles: ROLE_ADMIN }
        - { path: ^/oauth, roles: IS_AUTHENTICATED_ANONYMOUSLY }
